<?php
// +----------------------------------------------------------------------
// | JDCMS V2.0
// +----------------------------------------------------------------------
// | CREATE BY 合肥几度互联网络科技有限公司(http://www.ji-du.com.cn)
// +----------------------------------------------------------------------
namespace app\admin\controller;

use think\Db;
use think\Controller;

class Base extends Controller               
{
	public function _initialize()
    {
        $controller = request()->controller();
        $action =  request()->action();

        if (session('admin')) {
        	$admin = Db::name('admin')->where('id',session('admin.id'))->find();
        	$this->assign('admin',$admin);

            $nav = Db::name('admin_menu')->where('pid', 0)->where('is_show', 1)->order('rank')->select();
            foreach ($nav as $k => $v) {
                $child = Db::name('admin_menu')->where('pid', $v['id'])->where('is_show', 1)->order('rank')->select();
                $nav[$k]['child'] = $child;
            }
            $this->assign('nav', $nav);

            $url = 'http://'.$_SERVER['HTTP_HOST'].'/admin/'.$controller.'/'.$action.'.html';
            $this->assign('nowUrl', $url);

            $father_url = '';
            $action_pid = Db::name('admin_menu')->where(['c'=>$controller, 'a'=>$action])->value('pid');
            if ($action_pid) {
                $father_action = Db::name('admin_menu')->where('id', $action_pid)->value('a');
                $father_url = 'http://'.$_SERVER['HTTP_HOST'].'/admin/'.$controller.'/'.$father_action.'.html';
            }
            $this->assign('fatherUrl', $father_url);
            
            if ($admin['role_id'] != 1) {  
                if (!$this->getPower($controller, $action)) {
                    $this->redirect('admin/admin/error_html');
                }
            }
        } else {
			$this->redirect('admin/Login/login');
		}
    }

    public function getPower($controller, $action)
    {
        $id = session('admin.id');
        $admin_menu = Db::name('admin')->alias('a')->join('admin_role b', 'a.role_id=b.id', 'left')->where('a.id', $id)->field('b.nav_list')->find();

        if (!$admin_menu['nav_list']) {
            return false;
        }
        else {
            $arr = explode(',', $admin_menu['nav_list']);
            $now_menu_id = Db::name('admin_menu')->where(['c'=>$controller, 'a'=>$action])->value('id');
            if ($now_menu_id) {
                if (in_array($now_menu_id, $arr)) {
                    return true;
                } else {
                    return false;
                }  
            } else {    // 一些公共的操作方法
                return true;
            }
            
        }
    }

    // 面包屑
    public function nav($param)
    {
        $arr = explode('/',$param);
        $str = $arr[5];
        $arr2 = explode('.', $str);
        $data = ['c'=>$arr[4], 'a'=>$arr2[0]];
        $res = Db::name('admin_menu')->where($data)->find();
        $msg = [];
        if ($res['pid'] != 0) {
            $father = Db::name('admin_menu')->where('id', $res['pid'])->find();
            $msg['top'] = $father['name'];
            if ($father['a'] != '') {
                $msg['father_url'] = url($father['c'].'/'.$father['a']);
            } else {
                $msg['father_url'] = '#';
            }
            $msg['child'] = $res['name'];
            $msg['url']   = url($res['c'].'/'.$res['a']);
        } else {
            $msg['top'] = $res['name'];
            $msg['url'] = url($res['c'].'/'.$res['a']);
        }
        return ['status'=>1, 'msg'=>$msg];
    }

    // 定义当前链接
    public function getNowUrl()
    {
        
    }
}