<?php
// +----------------------------------------------------------------------
// | JDCMS V2.0
// +----------------------------------------------------------------------
// | CREATE BY 合肥几度互联网络科技有限公司(http://www.ji-du.com.cn)
// +----------------------------------------------------------------------
namespace app\admin\model;

use think\Model;
use think\Db;

class DiyField extends Model
{
    protected $name = 'auth_field';

    public function getAllFieldCount($mid, $type)
    {
        return $this->where(array('type'=>$type,'mid'=>$mid))->count();
    }

    public function delAllField($mid)
    {
        return $this->where(array('mid'=>$mid,'type'=>1))->delete();
    }

    // 获取单个模型的所有字段
    public function selectField($mid)
    {
        $item = $this->where(['mid'=>$mid,'type'=>1])->order('rank asc')->select();
        $product = empty($item) ? array() : $item->toArray();
        return $product;
    }

    public function selectFormField($mid)
    {
        $item = $this->where(array('mid'=>$mid,'type'=>2))->select();
        $product = empty($item) ? array() : $item->toArray();
        return $product;
    }

    public function delField($id)
    {
        return $this->where(array('id'=>$id))->delete();
    }

    public function delFieldForm($id)
    {
        return $this->where(array('mid'=>$id,'type'=>2))->delete();
    }

    public function findField($id)
    {
        $item = $this->where('id', $id)->find();
        $product = empty($item) ? array():$item->toArray();
        return $product;
    }

    public function findFormField($id)
    {
        $item = $this->where(array('id'=>$id,'type'=>2))->find();
        $product = empty($item) ? array():$item->toArray();
        return $product;
    }

    public function updateField($id, $param, $type=1)   // 1 字段，2 分组线
    {
        try {
            if ($type == 1) {
                if ($param['name'] == '' || $param['field'] == '' || $param['length'] == '') {
                    return ['status'=>-1, 'msg'=>'必填项不能为空'];
                }
            }
            $res = $this->allowField(['name', 'field', 'default_value', 'field_type', 'is_not_null', 'rank', 'length', 'remark'])->save($param, ['id'=>$id]);

            return $res ? ['status'=>1, 'msg'=>OK] : ['status'=>0, 'msg'=>FAIL];
        } catch (\PDOException $e) {
            return ['status'=>0, 'msg'=>FAIL.'2'];
        }
    }

    public function insertField($param)
    {
        try {
            if ($param['name'] == '' || $param['field'] == '' || $param['length'] == '') {
                return ['status'=>-1, 'msg'=>'必填项不能为空'];
            }
            $res = $this->allowField(true)->save($param);

            return $res ? ['status'=>1, 'msg'=>OK] : ['status'=>0, 'msg'=>FAIL];
        } catch (\PDOException $e) {
            return ['status'=>0, 'msg'=>FAIL.'2'];
        }
    }


}