<?php
// +----------------------------------------------------------------------
// | JDCMS V2.0
// +----------------------------------------------------------------------
// | CREATE BY 合肥几度互联网络科技有限公司(http://www.ji-du.com.cn)
// +----------------------------------------------------------------------
namespace app\index\model;

use think\Model;
use think\Db;

class Content extends Model
{
    protected $name = 'content';

    // 获取单个文章信息
    public function getContentById($id)
    {
        $res = $this->where('id', $id)->find();
        if ($res) {
            $res = $res->toArray();
            if ($res['jump_url'] != '') {
                $res['url'] = $res['jump_url'];
            } else {
                $res['url'] = config('sys.site_url').'/show/id/'.$id;
            }
        } else {
            $res = [];
        }
        return $res;
    }

    public function getOneContent($where=[], $order='rank asc, id desc')
    {
        $res = $this->where($where)->order($order)->find();
        if ($res) {
            $res = $res->toArray();
            $res['url'] = $res['jump_url'] != '' ? $res['jump_url'] : config('sys.site_url').'/show/id/'.$res['id'];
        } else {
            $res = [];
        }
        return $res;
    }

    /*
     *  获取内容地址    by wq
     *  id 内容id
     */
    public function getContentUrl($id)
    {
        $res = $this->get($id);
        if (!$res) {
            $url = '';
        } else {
            $url = $res['jump_url'] != '' ? $res['jump_url'] : config('sys.site_url').'/show/id/'.$id;
        }
        return $url;
    }

    /*
    *  文章浏览量 +1
    *  id 内容id
    */
    public function addContentBrowse($id)
    {
        $this->where('id', $id)->setInc('browse');
    }
}