<?php
// +----------------------------------------------------------------------
// | JDCMS V2.0
// +----------------------------------------------------------------------
// | DREATE BY 合肥几度互联网络科技有限公司(http://www.ji-du.com.cn)
// +----------------------------------------------------------------------
namespace app\admin\controller;

use app\admin\model\Content;
use app\admin\model\Category;
use app\admin\model\Browse;

class Index extends Base
{

	public function index()
	{
        $content_num  = Content::count();
        $category_num = Category::count();
        $browse_num   = Browse::count();
        $browse_today = Browse::whereTime('time', 'd')->count();

		$browse = [];
		for ($i = 6; $i >= 0; $i --) { 
            $start_time = strtotime(date('Y-m-d 00:00:00', strtotime("-".$i." day")));
            $end_time   = strtotime(date('Y-m-d 23:59:59', strtotime("-".$i." day")));
            $browse[]   = Browse::where('time', 'between time', [$start_time, $end_time])->count();
            $date[]     = date('m-d', strtotime("-".$i." day"));
        }

        $data = [
        	'content_num' 	=> $content_num,
            'category_num'	=> $category_num,
            'browse_num'    => $browse_num,
            'browse_today'  => $browse_today,
            'browse'		=> $browse,
            'date'          => $date
        ];
        $this->assign('data', $data);

        $hs_auth = action('Platform/authQuery');
        $this->assign('hs_auth', $hs_auth);
        
        return $this->fetch();
	}

    //清除缓存
    public function cache()
    {
        $path = RUNTIME_PATH;
        dir_del($path);
        return json(['status'=>1 ,'msg' => '清除缓存成功']);
    }
}