<?php
use think\Db;

// 写入基本配置，方便调用
$sys = [];
$sys_config = Db::name('config')->where('type', 'in', '1,2,3')->select();
foreach ($sys_config as $key => $val) {
    $sys[$val['tag']] = $val['val'];
}

$config =
    [
        //模板设置
        'template' 		=> [
            // 模板引擎类型 支持 php think 支持扩展
            'type'         => 'Think',
            // 模板路径
            'view_path'    => '/template/default/',
            // 模板后缀
            'view_suffix'  => 'html',
            // 模板文件名分隔符
            'view_depr'    => DS,
            // 模板引擎普通标签开始标记
            'tpl_begin'    => '{',
            // 模板引擎普通标签结束标记
            'tpl_end'      => '}',
            // 标签库标签开始标记
            'taglib_begin' => '<',
            // 标签库标签结束标记
            'taglib_end'   => '>',
            //模板文件名
            'default_theme' => 'default',
            // 预先加载的标签库
            'taglib_pre_load'   =>  'app\index\taglib\Jidu',
        ],
        // 视图输出字符串内容替换
        'view_replace_str'  =>  [
            '__TEM__'   => '/template/default',
        ],
        'sys'   => $sys,
        //分页配置
        'paginate'      => [
            'type'      => 'common\Page',//分页类
            'var_page'  => 'page',
            'list_rows' => 15,
        ],
    ];
return $config;
?>