<?php
// +----------------------------------------------------------------------
// | JDCMS V2.0
// +----------------------------------------------------------------------
// | CREATE BY 合肥几度互联网络科技有限公司(http://www.ji-du.com.cn)
// +----------------------------------------------------------------------
namespace app\index\controller;

use think\Controller;
use think\Db;

class Common extends Controller
{
    /* 初始化 */
    public function _initialize()
    {
        $site_type =  isMobile() ? 'wap' : 'pc';
        $this->assign('site_type', $site_type);

        // SEO优化
        $seo_title = Db::name('config')->where('tag', 'seo_title')->value('val') ? : '';
        $seo_keywords = Db::name('config')->where('tag', 'seo_keywords')->value('val') ? : '';
        $seo_describe = Db::name('config')->where('tag', 'seo_describe')->value('val') ? : '';

        $path_info = isset($_SERVER['PATH_INFO']) ? $_SERVER['PATH_INFO'] : '';
        if ($path_info != '') {
        	$path_info = substr($path_info, 1);
        	$category  = Db::name('category')->where('tag', $path_info)->field('title, seo_title, seo_keywords, seo_describe')->find();
        	if ($category) {
        		$cate_seo = $category['seo_title']!='' ? $category['seo_title'] : ($category['title']!='' ? $category['title'] : '');
        		if ($cate_seo != '') {
        			$seo_title = $cate_seo.' - '.$seo_title;
        		}
        		if ($category['seo_keywords']!='') {
        			$seo_keywords = $category['seo_keywords'];
        		}
        		if ($category['seo_describe']!='') {
        			$seo_describe = $category['seo_describe'];
        		}
        	}

        	if ($path_info == 'show.html') {
        		$content_id = input('id') ? input('id') : -1;
        		$content = Db::name('content')->where('id', $content_id)->field('title, cid, seo_title, seo_keywords, seo_describe')->find();
        		if ($content) {
        			$category = Db::name('category')->where('id', $content['cid'])->field('title, seo_title, seo_keywords, seo_describe')->find();
        			if ($category) {
		        		$cate_seo = $category['seo_title']!='' ? $category['seo_title'] : ($category['title']!='' ? $category['title'] : '');
		        		if ($cate_seo != '') {
		        			$seo_title = $cate_seo.' - '.$seo_title;
		        		}
		        		if ($category['seo_keywords']!='') {
		        			$seo_keywords = $category['seo_keywords'];
		        		}
		        		if ($category['seo_describe']!='') {
		        			$seo_describe = $category['seo_describe'];
		        		}
		        	}
        			$content_seo = $content['seo_title']!='' ? $content['seo_title'] : ($content['title']!='' ? $content['title'] : '');
        			if ($content_seo != '') {
	        			$seo_title = $content_seo.' - '.$seo_title;
	        		}
	        		if ($content['seo_keywords']!='') {
	        			$seo_keywords = $content['seo_keywords'];
	        		}
	        		if ($content['seo_describe']!='') {
	        			$seo_describe = $content['seo_describe'];
	        		}
        		}
        	}
        }
       	$this->assign('seo_title', trim($seo_title));
       	$this->assign('seo_keywords', trim($seo_keywords));
       	$this->assign('seo_describe', trim($seo_describe));
    }
}