<?php
// +----------------------------------------------------------------------
// | JDCMS V2.0
// +----------------------------------------------------------------------
// | CREATE BY 合肥几度互联网络科技有限公司(http://www.ji-du.com.cn)
// +----------------------------------------------------------------------
namespace app\index\model;

use think\Model;

class Block extends Model
{
    protected $name = 'block';

    // 获取单个自定义块信息 tag 块标识, class 前端类名
    public function getSingBlock($tag, $class)
    {
        $res = $this->where('tag', $tag)->find();
        $info = [];
        if ($res) {
            $res = $res->toArray();
            $info['name']    = $res['name'];
            if ($res['url'] != '') {    // 定义了外链，什么都不需要考虑，直接按照传文本的来处理，返回a链接即可
                $info['content'] = '<a href=\''.$res['url'].'\' target=\'_blank\'>'.$res['url'].'</a>';
            } else {
                if ($res['type'] == 1) {    // 文字
                    $info['content'] = $res['content'];
                } else if ($res['type'] == 2) { // 图片
                    $info['content'] = '<img src="'.$res['content'].'" class="'.$class.'">';
                } else if ($res['type'] == 3) { // 富文本
                    $info['content'] = $res['content'];
                } else if ($res['type'] == 4) { // 视频
                    $info['content'] = '<video src="'.$res['content'].'" controls="controls" class="'.$class.'">您的浏览器不支持 video 标签。</video>';
                } else if ($res['type'] == 5) { // 音频
                    $info['content'] = '<audio src="'.$res['content'].'" class="'.$class.'">您的浏览器不支持 audio 标签。</audio>';
                }
            }
        } else {
            $info = ['name'=>'', 'content'=>''];
        }
        return $info;
    }
}