/*
 Navicat Premium Data Transfer

 Source Server         : localhost_3306
 Source Server Type    : MySQL
 Source Server Version : 50553
 Source Host           : localhost:3306
 Source Schema         : puredemo

 Target Server Type    : MySQL
 Target Server Version : 50553
 File Encoding         : 65001

 Date: 20/05/2020 18:03:39
*/

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for jd_admin
-- ----------------------------
DROP TABLE IF EXISTS `jd_admin`;
CREATE TABLE `jd_admin`  (
  `id` smallint(5) NOT NULL AUTO_INCREMENT,
  `name` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `pass` varchar(60) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `real_name` varchar(10) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `time` datetime NULL DEFAULT NULL,
  `last_time` datetime NULL DEFAULT NULL,
  `last_ip` varchar(15) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `role_id` smallint(5) NULL DEFAULT NULL,
  `is_active` tinyint(1) NOT NULL DEFAULT 1,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 2 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '管理员表' ROW_FORMAT = Compact;

-- ----------------------------
-- Records of jd_admin
-- ----------------------------
INSERT INTO `jd_admin` VALUES (1, 'admin', '$2y$10$UeGTNIBPmj/CO0p3j67muObc8O6DF/CWv0posmQrp748nJK9ZsY5K', '', '0000-00-00 00:00:00', '2020-05-20 17:46:26', '127.0.0.1', 1, 1);

-- ----------------------------
-- Table structure for jd_admin_log
-- ----------------------------
DROP TABLE IF EXISTS `jd_admin_log`;
CREATE TABLE `jd_admin_log`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `admin_id` smallint(5) NOT NULL,
  `admin_name` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `info` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `ip` varchar(30) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `status` tinyint(1) NOT NULL,
  `time` datetime NOT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '管理员日志表' ROW_FORMAT = Compact;

-- ----------------------------
-- Table structure for jd_admin_menu
-- ----------------------------
DROP TABLE IF EXISTS `jd_admin_menu`;
CREATE TABLE `jd_admin_menu`  (
  `id` smallint(5) NOT NULL AUTO_INCREMENT,
  `name` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `pid` smallint(5) NOT NULL DEFAULT 0,
  `c` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `a` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `css` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `is_show` tinyint(1) NULL DEFAULT NULL,
  `rank` smallint(5) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 90 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '后台菜单表' ROW_FORMAT = Compact;

-- ----------------------------
-- Records of jd_admin_menu
-- ----------------------------
INSERT INTO `jd_admin_menu` VALUES (1, '管理控制台', 0, 'Index', 'index', 'fa fa-desktop', 1, 1);
INSERT INTO `jd_admin_menu` VALUES (2, '基本设置', 0, 'Config', '', 'fa fa-gears', 1, 20);
INSERT INTO `jd_admin_menu` VALUES (3, 'SEO设置', 2, 'Config', 'seo', 'fa fa-sun-o', 1, 23);
INSERT INTO `jd_admin_menu` VALUES (4, '网站设置', 2, 'Config', 'basic', 'fa fa-asterisk', 1, 22);
INSERT INTO `jd_admin_menu` VALUES (5, '友情链接', 83, 'Config', 'link', 'fa fa-anchor', 1, 23);
INSERT INTO `jd_admin_menu` VALUES (6, '添加友情链接', 5, 'Config', 'linkAdd', '', 1, 24);
INSERT INTO `jd_admin_menu` VALUES (7, '编辑友情链接', 5, 'Config', 'linkEdit', '', 1, 24);
INSERT INTO `jd_admin_menu` VALUES (8, '删除友情链接', 5, 'Config', 'linkDel', '', 0, 24);
INSERT INTO `jd_admin_menu` VALUES (9, '轮播管理', 83, 'Config', 'banner', 'fa fa-image', 1, 22);
INSERT INTO `jd_admin_menu` VALUES (10, '添加轮播图', 9, 'Config', 'bannerAdd', '', 0, 26);
INSERT INTO `jd_admin_menu` VALUES (11, '编辑轮播图', 9, 'Config', 'bannerEdit', '', 0, 26);
INSERT INTO `jd_admin_menu` VALUES (12, '删除轮播图', 9, 'Config', 'bannerDel', '', 0, 26);
INSERT INTO `jd_admin_menu` VALUES (13, '自定义块', 83, 'Block', 'cat', 'fa fa-leaf', 1, 27);
INSERT INTO `jd_admin_menu` VALUES (14, '添加自定义块分类', 13, 'Block', 'catAdd', '', 0, 28);
INSERT INTO `jd_admin_menu` VALUES (15, '编辑自定义块分类', 13, 'Block', 'catEdit', '', 0, 28);
INSERT INTO `jd_admin_menu` VALUES (16, '删除自定义块分类', 13, 'Block', 'catDel', '', 0, 28);
INSERT INTO `jd_admin_menu` VALUES (17, '自定义块管理', 13, 'Block', 'index', '', 0, 28);
INSERT INTO `jd_admin_menu` VALUES (18, '新增自定义块', 13, 'Block', 'add', '', 0, 28);
INSERT INTO `jd_admin_menu` VALUES (19, '编辑自定义块', 13, 'Block', 'edit', '', 0, 28);
INSERT INTO `jd_admin_menu` VALUES (20, '删除自定义块', 13, 'Block', 'del', '', 0, 28);
INSERT INTO `jd_admin_menu` VALUES (21, '站点地图', 85, 'Config', 'sitemap', 'fa fa-sitemap', 1, 29);
INSERT INTO `jd_admin_menu` VALUES (22, '栏目管理', 0, 'Category', 'index', 'fa fa-bars', 1, 30);
INSERT INTO `jd_admin_menu` VALUES (23, '添加栏目', 22, 'Category', 'add', '', 0, 31);
INSERT INTO `jd_admin_menu` VALUES (24, '编辑栏目', 22, 'Category', 'edit', '', 0, 31);
INSERT INTO `jd_admin_menu` VALUES (25, '删除栏目', 22, 'Category', 'del', '', 0, 31);
INSERT INTO `jd_admin_menu` VALUES (26, '内容管理', 0, 'Content', 'index', 'fa fa-book', 1, 40);
INSERT INTO `jd_admin_menu` VALUES (27, '添加内容', 26, 'Content', 'add', '', 0, 41);
INSERT INTO `jd_admin_menu` VALUES (28, '编辑内容', 26, 'Content', 'edit', '', 0, 41);
INSERT INTO `jd_admin_menu` VALUES (29, '删除内容', 26, 'Content', 'del', '', 0, 41);
INSERT INTO `jd_admin_menu` VALUES (30, '系统管理', 0, 'System', '', 'fa fa-futbol-o', 1, 50);
INSERT INTO `jd_admin_menu` VALUES (31, '菜单管理', 30, 'Menu', 'index', 'fa fa-puzzle-piece', 1, 51);
INSERT INTO `jd_admin_menu` VALUES (32, '添加菜单', 31, 'Menu', 'add', '', 0, 52);
INSERT INTO `jd_admin_menu` VALUES (33, '编辑菜单', 31, 'Menu', 'edit', '', 0, 52);
INSERT INTO `jd_admin_menu` VALUES (34, '删除菜单', 31, 'Menu', 'del', '', 0, 52);
INSERT INTO `jd_admin_menu` VALUES (35, '模型管理', 30, 'Diymode', 'index', 'fa fa-bullseye', 1, 53);
INSERT INTO `jd_admin_menu` VALUES (36, '添加模型', 35, 'Diymode', 'add', '', 1, 54);
INSERT INTO `jd_admin_menu` VALUES (37, '编辑模型', 35, 'Diymode', 'edit', '', 0, 54);
INSERT INTO `jd_admin_menu` VALUES (38, '删除模型', 35, 'Diymode', 'del', '', 0, 54);
INSERT INTO `jd_admin_menu` VALUES (39, '字段管理', 35, 'Diymode', 'field', '', 0, 54);
INSERT INTO `jd_admin_menu` VALUES (40, '添加字段', 35, 'Diymode', 'fieldAdd', '', 0, 54);
INSERT INTO `jd_admin_menu` VALUES (41, '编辑字段', 35, 'Diymode', 'fieldEdit', '', 0, 54);
INSERT INTO `jd_admin_menu` VALUES (42, '删除字段', 35, 'Diymode', 'fieldDel', '', 1, 54);
INSERT INTO `jd_admin_menu` VALUES (43, '表单管理', 30, 'Diyforms', 'index', 'fa fa-trello', 1, 54);
INSERT INTO `jd_admin_menu` VALUES (44, '新增表单', 43, 'Diyforms', 'add', '', 0, 55);
INSERT INTO `jd_admin_menu` VALUES (45, '编辑表单', 43, 'Diyforms', 'edit', '', 0, 55);
INSERT INTO `jd_admin_menu` VALUES (46, '删除表单', 43, 'Diyforms', 'del', '', 0, 55);
INSERT INTO `jd_admin_menu` VALUES (47, '字段管理', 43, 'Diyforms', 'field', '', 0, 56);
INSERT INTO `jd_admin_menu` VALUES (48, '新增表单字段', 43, 'Diyforms', 'fieldAdd', '', 0, 56);
INSERT INTO `jd_admin_menu` VALUES (49, '编辑表单字段', 43, 'Diyforms', 'fieldEdit', '', 0, 56);
INSERT INTO `jd_admin_menu` VALUES (50, '删除表单字段', 43, 'Diyforms', 'fieldDel', '', 0, 56);
INSERT INTO `jd_admin_menu` VALUES (51, '表单内容', 43, 'Diyforms', 'content', '', 0, 56);
INSERT INTO `jd_admin_menu` VALUES (52, '查看表单内容', 43, 'Diyforms', 'contentSee', '', 0, 56);
INSERT INTO `jd_admin_menu` VALUES (53, '删除表单内容', 43, 'Diyforms', 'contentDel', '', 0, 56);
INSERT INTO `jd_admin_menu` VALUES (55, '上传设置', 2, 'Config', 'upload', 'fa fa-cloud-upload', 1, 57);
INSERT INTO `jd_admin_menu` VALUES (56, '站内资源管理', 30, 'Resource', 'index', 'fa fa-stack-overflow', 1, 57);
INSERT INTO `jd_admin_menu` VALUES (57, '角色管理', 82, 'Admin', 'role', 'fa fa-star', 1, 100);
INSERT INTO `jd_admin_menu` VALUES (58, '添加角色', 57, 'Admin', 'roleAdd', '', 1, 50);
INSERT INTO `jd_admin_menu` VALUES (59, '编辑角色', 57, 'Admin', 'roleEdit', '', 0, 58);
INSERT INTO `jd_admin_menu` VALUES (60, '删除角色', 57, 'Admin', 'roleDel', '', 0, 58);
INSERT INTO `jd_admin_menu` VALUES (61, '管理员管理', 82, 'Admin', 'index', 'fa fa-users', 1, 70);
INSERT INTO `jd_admin_menu` VALUES (62, '添加管理员', 61, 'Admin', 'add', '', 0, 59);
INSERT INTO `jd_admin_menu` VALUES (63, '编辑管理员', 61, 'Admin', 'edit', '', 0, 59);
INSERT INTO `jd_admin_menu` VALUES (64, '删除管理员', 61, 'Admin', 'del', '', 0, 59);
INSERT INTO `jd_admin_menu` VALUES (65, '我的设置', 82, 'Admin', 'info', 'fa fa-user', 1, 60);
INSERT INTO `jd_admin_menu` VALUES (66, '数据库管理', 85, 'Data', 'index', 'fa fa-database', 1, 61);
INSERT INTO `jd_admin_menu` VALUES (67, '数据库恢复', 66, 'Data', 'recover', '', 0, 62);
INSERT INTO `jd_admin_menu` VALUES (68, '数据库备份', 66, 'Data', 'backup', '', 0, 0);
INSERT INTO `jd_admin_menu` VALUES (69, '数据库备份', 66, 'Data', 'backups', '', 0, 62);
INSERT INTO `jd_admin_menu` VALUES (70, '日志管理', 85, 'Log', 'index', 'fa fa-calendar', 1, 63);
INSERT INTO `jd_admin_menu` VALUES (71, '平台管理', 85, 'Platform', 'index', 'fa fa-cube', 1, 66);
INSERT INTO `jd_admin_menu` VALUES (72, '批量操作', 22, 'Category', 'batch', '', 0, 50);
INSERT INTO `jd_admin_menu` VALUES (76, '新增分组线', 35, 'Diymode', 'lineAdd', '', 1, 55);
INSERT INTO `jd_admin_menu` VALUES (77, '编辑分组线', 35, 'Diymode', 'lineEdit', '', 1, 55);
INSERT INTO `jd_admin_menu` VALUES (78, '复制模型', 35, 'Diymode', 'copy', '', 1, 50);
INSERT INTO `jd_admin_menu` VALUES (82, '管理员中心', 0, 'Admin', 'index', 'fa fa-users', 1, 55);
INSERT INTO `jd_admin_menu` VALUES (83, '插件管理', 0, 'Plugin', 'fa fa-plug', 'fa fa-plug', 1, 70);
INSERT INTO `jd_admin_menu` VALUES (84, '水印设置', 2, 'Config', 'water', 'fa fa-crop', 1, 60);
INSERT INTO `jd_admin_menu` VALUES (85, '数据与安全', 0, 'Data', '', 'fa fa-cubes', 1, 80);
INSERT INTO `jd_admin_menu` VALUES (86, '导出表单数据', 43, 'Diyforms', 'contentExport', '', 0, 57);
INSERT INTO `jd_admin_menu` VALUES (87, '模版更新列表', 71, 'Platform', 'renewtpl', '', 0, 50);
INSERT INTO `jd_admin_menu` VALUES (88, '升级文件列表', 71, 'Platform', 'upgrade', '', 0, 50);
INSERT INTO `jd_admin_menu` VALUES (89, '邮箱设置', 2, 'Config', 'email', 'fa fa-envelope-o', 1, 100);

-- ----------------------------
-- Table structure for jd_admin_role
-- ----------------------------
DROP TABLE IF EXISTS `jd_admin_role`;
CREATE TABLE `jd_admin_role`  (
  `id` smallint(6) NOT NULL AUTO_INCREMENT,
  `name` varchar(30) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `nav_list` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL,
  `column_list` text CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '栏目权限',
  `insert_time` datetime NOT NULL COMMENT '添加此栏目的时间',
  `update_time` datetime NULL DEFAULT NULL COMMENT '修改此角色的时间',
  `desc` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `status` smallint(2) NOT NULL DEFAULT 1 COMMENT '1:启用此角色：2：禁用此角色',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 4 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '管理员角色表' ROW_FORMAT = Compact;

-- ----------------------------
-- Records of jd_admin_role
-- ----------------------------
INSERT INTO `jd_admin_role` VALUES (1, '超级管理员', '1,2,3,4,5,6,7,8,9,10,11,12,13,15,16,17,22,23,24,30,35,36,43,44,46,47,48,50,51', '1,4,5,2', '2019-11-15 00:00:00', '2019-11-22 00:00:00', '拥有最高权限', 1);

-- ----------------------------
-- Table structure for jd_auth_field
-- ----------------------------
DROP TABLE IF EXISTS `jd_auth_field`;
CREATE TABLE `jd_auth_field`  (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自定义表单字段id',
  `type` tinyint(1) NOT NULL COMMENT '1 模型表字段，2 表单模型表字段',
  `mid` int(11) NOT NULL COMMENT '自定义数据表id',
  `name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '字段中文名称',
  `field` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '字段英文名称',
  `default_value` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '字段默认值',
  `field_type` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '字段值类型',
  `is_not_null` tinyint(1) NOT NULL DEFAULT 1 COMMENT '必填：1是，0否',
  `rank` smallint(5) NOT NULL DEFAULT 50 COMMENT '字段排序（正序：0~99999）',
  `length` int(9) NULL DEFAULT NULL COMMENT '字段长度',
  `remark` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '备注',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 11 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '自定义表单字段表' ROW_FORMAT = Compact;

-- ----------------------------
-- Records of jd_auth_field
-- ----------------------------
INSERT INTO `jd_auth_field` VALUES (1, 1, 1, '标题', 'diy_title', '', 'text', 0, 50, 50, '文章标题');
INSERT INTO `jd_auth_field` VALUES (2, 1, 1, '作者', 'author', '', 'text', 0, 50, 20, '文章发布者');
INSERT INTO `jd_auth_field` VALUES (3, 1, 1, '描述', 'desc', '', 'seditor', 1, 50, 500, '文章描述');
INSERT INTO `jd_auth_field` VALUES (4, 1, 1, '内容', 'content', '', 'editor', 1, 50, 0, '文章内容');
INSERT INTO `jd_auth_field` VALUES (5, 1, 1, '时间', 'diy_time', '', 'datetime', 0, 50, 0, '文章发布时间');
INSERT INTO `jd_auth_field` VALUES (6, 1, 2, '名称', 'diy_title', '', 'text', 0, 50, 50, '产品名称');
INSERT INTO `jd_auth_field` VALUES (7, 1, 2, '展示图', 'diy_img', '', 'image', 1, 50, 255, '产品展示图');
INSERT INTO `jd_auth_field` VALUES (8, 1, 2, '简介', 'desc', '', 'seditor', 1, 50, 500, '产品简介');
INSERT INTO `jd_auth_field` VALUES (9, 1, 2, '详情', 'content', '', 'editor', 1, 50, 0, '产品详情');
INSERT INTO `jd_auth_field` VALUES (10, 1, 2, '时间', 'diy_time', '', 'datetime', 1, 50, 0, '发布产品时间');

-- ----------------------------
-- Table structure for jd_auth_form
-- ----------------------------
DROP TABLE IF EXISTS `jd_auth_form`;
CREATE TABLE `jd_auth_form`  (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '自定义表单id',
  `name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '表中文名称',
  `table_name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '表英文名称',
  `remark` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '备注',
  `is_verify` tinyint(1) NOT NULL DEFAULT 0 COMMENT '是否开启验证：1是，0否',
  `rank` smallint(5) NOT NULL DEFAULT 50 COMMENT '排序',
  `is_send_email` tinyint(1) NOT NULL DEFAULT 0 COMMENT '1 发邮件，0不发（先不做）',
  `email` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '邮箱',
  `email_title` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '邮件名称',
  `email_content` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL COMMENT '邮件内容',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '表单模型表，表中每一条数据代表一个表' ROW_FORMAT = Compact;

-- ----------------------------
-- Table structure for jd_auth_model
-- ----------------------------
DROP TABLE IF EXISTS `jd_auth_model`;
CREATE TABLE `jd_auth_model`  (
  `id` smallint(5) NOT NULL AUTO_INCREMENT COMMENT '模型id',
  `type` tinyint(1) NOT NULL DEFAULT 2 COMMENT '1系统模型，2自定义',
  `name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '模型名称',
  `table_name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '对应的表名称',
  `remark` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '备注',
  `rank` smallint(5) NOT NULL DEFAULT 50 COMMENT '排序',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 3 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '模型表，表中每一条数据代表一个表' ROW_FORMAT = Compact;

-- ----------------------------
-- Records of jd_auth_model
-- ----------------------------
INSERT INTO `jd_auth_model` VALUES (1, 1, '文章模型', 'article', '文章模型', 1);
INSERT INTO `jd_auth_model` VALUES (2, 1, '产品模型', 'product', '产品模型', 1);

-- ----------------------------
-- Table structure for jd_banner
-- ----------------------------
DROP TABLE IF EXISTS `jd_banner`;
CREATE TABLE `jd_banner`  (
  `id` smallint(6) NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `title` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '名称',
  `img` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '图片路径',
  `url` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '跳转链接',
  `type` tinyint(1) NOT NULL COMMENT '1PC 2WAP',
  `rank` smallint(5) NOT NULL DEFAULT 50 COMMENT '排序',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 8 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = 'banner表' ROW_FORMAT = Compact;

-- ----------------------------
-- Table structure for jd_block
-- ----------------------------
DROP TABLE IF EXISTS `jd_block`;
CREATE TABLE `jd_block`  (
  `id` smallint(5) NOT NULL AUTO_INCREMENT COMMENT '自定义块id',
  `cid` smallint(5) NOT NULL COMMENT '分类id',
  `type` tinyint(1) NOT NULL COMMENT '1文字，2图片，3富文本，4视频，5音频',
  `name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '自定义名称',
  `tag` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '自定义块英文标识',
  `content` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL COMMENT '内容',
  `url` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '跳转链接',
  `remark` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '备注说明',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 8 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '自定义块表' ROW_FORMAT = Compact;

-- ----------------------------
-- Records of jd_block
-- ----------------------------
INSERT INTO `jd_block` VALUES (1, 1, 2, 'LOGO', 'LOGO', '/uploads/20191101/4222cdf67dfe573a073bf35cb3a0503a.png', '', 'logo');
INSERT INTO `jd_block` VALUES (2, 2, 3, '底部信息', 'footer', '<p>TEL：010-88888888 MOB:13888888888 EMAIL：66666666@qq.com</p><p>本软件已进行版权登记，相关权利受法律保护，著作权信息：中华人民共和国国家版权局 计算机软件著作权登记证书：2018SR118857</p><p>版权所有 © 2019 几度CMS企业网站管理系统（<a href=\"http://www.jiducms.com）合肥几度互联网络科技有限公司\">www.jiducms.com）合肥几度互联网络科技有限公司</a>&nbsp; 保留所有权利 Powered by JIDUCMS2.0.0</p><p>提示说明：本网站数据只供几度CMS功能演示使用，相关数据不具真实性，如需要了解几度CMS的相关功能请访问几度CMS官网</p>', '', '');
INSERT INTO `jd_block` VALUES (3, 3, 1, 'qq客服1', 'kefu1', '<a target=\"_blank\" href=\"http://wpa.qq.com/msgrd?v=3&uin=260901718&site=qq&menu=yes\">在线客服<br />                            <img  src=\"http://wpa.qq.com/pa?p=2:260901718:47\" alt=\"点击这里给我发消息\" title=\"点击这里给我发消息\" border=\"0\">                        </a>', '', '');
INSERT INTO `jd_block` VALUES (5, 3, 1, '淘宝客服', 'kefu3', '<a target=\"_blank\" class=\"kefu_Type_msn\" href=\"http://amos1.taobao.com/msg.ww?v=2&amp;uid=富杰工程机械&amp;s=1\">                            <img src=\"http://amos1.taobao.com/online.ww?v=2&amp;uid=富杰工程机械&amp;s=1\" alt=\"点击这里给我发消息\" border=\"0\">                        </a>', '', '');
INSERT INTO `jd_block` VALUES (6, 3, 2, '联系我们二维吗', 'lxwm', '/uploads/20191118/17070afbca035dfcd22b61336b8dd199.jpg', '', '');
INSERT INTO `jd_block` VALUES (7, 2, 1, '手机底部', 'footer_wap', '几度CMS', '', '');

-- ----------------------------
-- Table structure for jd_block_cat
-- ----------------------------
DROP TABLE IF EXISTS `jd_block_cat`;
CREATE TABLE `jd_block_cat`  (
  `id` smallint(5) NOT NULL AUTO_INCREMENT COMMENT '自定义块分类id',
  `name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '名称',
  `rank` smallint(5) NOT NULL DEFAULT 50 COMMENT '排序',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 4 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '自定义块分类表' ROW_FORMAT = Compact;

-- ----------------------------
-- Table structure for jd_browse
-- ----------------------------
DROP TABLE IF EXISTS `jd_browse`;
CREATE TABLE `jd_browse`  (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'ID',
  `ip` varchar(15) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '用户IP',
  `time` datetime NOT NULL COMMENT '时间',
  `type` tinyint(1) NOT NULL COMMENT '1PC 2WAP',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 845 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '用户浏览量统计表' ROW_FORMAT = Compact;

-- ----------------------------
-- Records of jd_browse
-- ----------------------------
INSERT INTO `jd_browse` VALUES (783, '127.0.0.1', '2020-05-18 09:05:55', 1);
INSERT INTO `jd_browse` VALUES (784, '127.0.0.1', '2020-05-18 09:25:07', 1);
INSERT INTO `jd_browse` VALUES (785, '127.0.0.1', '2020-05-18 09:25:10', 1);
INSERT INTO `jd_browse` VALUES (786, '127.0.0.1', '2020-05-18 09:25:12', 1);
INSERT INTO `jd_browse` VALUES (787, '127.0.0.1', '2020-05-18 09:25:13', 1);
INSERT INTO `jd_browse` VALUES (788, '127.0.0.1', '2020-05-18 14:51:27', 1);
INSERT INTO `jd_browse` VALUES (789, '127.0.0.1', '2020-05-18 14:53:24', 1);
INSERT INTO `jd_browse` VALUES (790, '127.0.0.1', '2020-05-18 14:53:50', 1);
INSERT INTO `jd_browse` VALUES (791, '127.0.0.1', '2020-05-18 14:54:37', 1);
INSERT INTO `jd_browse` VALUES (792, '127.0.0.1', '2020-05-18 14:54:43', 1);
INSERT INTO `jd_browse` VALUES (793, '127.0.0.1', '2020-05-18 14:54:51', 1);
INSERT INTO `jd_browse` VALUES (794, '127.0.0.1', '2020-05-18 15:16:52', 1);
INSERT INTO `jd_browse` VALUES (795, '127.0.0.1', '2020-05-18 15:30:53', 1);
INSERT INTO `jd_browse` VALUES (796, '127.0.0.1', '2020-05-18 16:16:17', 1);
INSERT INTO `jd_browse` VALUES (797, '127.0.0.1', '2020-05-18 16:16:29', 1);
INSERT INTO `jd_browse` VALUES (798, '127.0.0.1', '2020-05-18 16:57:33', 1);
INSERT INTO `jd_browse` VALUES (799, '127.0.0.1', '2020-05-18 16:57:36', 1);
INSERT INTO `jd_browse` VALUES (800, '127.0.0.1', '2020-05-18 17:01:27', 1);
INSERT INTO `jd_browse` VALUES (801, '127.0.0.1', '2020-05-18 17:01:32', 1);
INSERT INTO `jd_browse` VALUES (802, '127.0.0.1', '2020-05-18 17:01:42', 1);
INSERT INTO `jd_browse` VALUES (803, '127.0.0.1', '2020-05-18 17:01:51', 1);
INSERT INTO `jd_browse` VALUES (804, '127.0.0.1', '2020-05-18 17:02:08', 1);
INSERT INTO `jd_browse` VALUES (805, '127.0.0.1', '2020-05-18 17:03:07', 1);
INSERT INTO `jd_browse` VALUES (806, '127.0.0.1', '2020-05-18 17:03:17', 1);
INSERT INTO `jd_browse` VALUES (807, '127.0.0.1', '2020-05-18 17:03:56', 1);
INSERT INTO `jd_browse` VALUES (808, '127.0.0.1', '2020-05-18 17:12:53', 1);
INSERT INTO `jd_browse` VALUES (809, '127.0.0.1', '2020-05-18 17:35:05', 1);
INSERT INTO `jd_browse` VALUES (810, '127.0.0.1', '2020-05-18 17:35:14', 1);
INSERT INTO `jd_browse` VALUES (811, '127.0.0.1', '2020-05-19 09:27:06', 1);
INSERT INTO `jd_browse` VALUES (812, '127.0.0.1', '2020-05-19 11:09:11', 1);
INSERT INTO `jd_browse` VALUES (813, '127.0.0.1', '2020-05-19 14:07:42', 1);
INSERT INTO `jd_browse` VALUES (814, '127.0.0.1', '2020-05-19 14:08:19', 1);
INSERT INTO `jd_browse` VALUES (815, '127.0.0.1', '2020-05-19 14:08:26', 1);
INSERT INTO `jd_browse` VALUES (816, '127.0.0.1', '2020-05-19 14:13:50', 1);
INSERT INTO `jd_browse` VALUES (817, '127.0.0.1', '2020-05-19 15:49:37', 1);
INSERT INTO `jd_browse` VALUES (818, '127.0.0.1', '2020-05-19 15:49:44', 1);
INSERT INTO `jd_browse` VALUES (819, '127.0.0.1', '2020-05-19 15:51:26', 1);
INSERT INTO `jd_browse` VALUES (820, '127.0.0.1', '2020-05-19 15:56:20', 1);
INSERT INTO `jd_browse` VALUES (821, '127.0.0.1', '2020-05-19 15:57:05', 1);
INSERT INTO `jd_browse` VALUES (822, '127.0.0.1', '2020-05-19 15:57:20', 1);
INSERT INTO `jd_browse` VALUES (823, '127.0.0.1', '2020-05-19 15:57:59', 1);
INSERT INTO `jd_browse` VALUES (824, '127.0.0.1', '2020-05-19 15:58:49', 1);
INSERT INTO `jd_browse` VALUES (825, '127.0.0.1', '2020-05-19 16:00:34', 1);
INSERT INTO `jd_browse` VALUES (826, '127.0.0.1', '2020-05-19 16:00:53', 1);
INSERT INTO `jd_browse` VALUES (827, '127.0.0.1', '2020-05-19 18:08:36', 1);
INSERT INTO `jd_browse` VALUES (828, '127.0.0.1', '2020-05-19 18:08:42', 1);
INSERT INTO `jd_browse` VALUES (829, '127.0.0.1', '2020-05-19 18:08:48', 1);
INSERT INTO `jd_browse` VALUES (830, '127.0.0.1', '2020-05-19 18:10:40', 1);
INSERT INTO `jd_browse` VALUES (831, '127.0.0.1', '2020-05-19 18:10:45', 1);
INSERT INTO `jd_browse` VALUES (832, '127.0.0.1', '2020-05-19 18:12:31', 1);
INSERT INTO `jd_browse` VALUES (833, '127.0.0.1', '2020-05-19 18:18:21', 1);
INSERT INTO `jd_browse` VALUES (834, '127.0.0.1', '2020-05-20 09:09:26', 1);
INSERT INTO `jd_browse` VALUES (835, '127.0.0.1', '2020-05-20 11:04:31', 1);
INSERT INTO `jd_browse` VALUES (836, '127.0.0.1', '2020-05-20 11:05:10', 1);
INSERT INTO `jd_browse` VALUES (837, '127.0.0.1', '2020-05-20 11:05:44', 1);
INSERT INTO `jd_browse` VALUES (838, '127.0.0.1', '2020-05-20 11:11:55', 1);
INSERT INTO `jd_browse` VALUES (839, '127.0.0.1', '2020-05-20 11:14:04', 1);
INSERT INTO `jd_browse` VALUES (840, '127.0.0.1', '2020-05-20 11:43:29', 1);
INSERT INTO `jd_browse` VALUES (841, '127.0.0.1', '2020-05-20 11:45:06', 1);
INSERT INTO `jd_browse` VALUES (842, '127.0.0.1', '2020-05-20 11:47:02', 1);
INSERT INTO `jd_browse` VALUES (843, '127.0.0.1', '2020-05-20 11:55:04', 1);
INSERT INTO `jd_browse` VALUES (844, '127.0.0.1', '2020-05-20 17:46:04', 1);

-- ----------------------------
-- Table structure for jd_category
-- ----------------------------
DROP TABLE IF EXISTS `jd_category`;
CREATE TABLE `jd_category`  (
  `id` int(9) NOT NULL AUTO_INCREMENT COMMENT '栏目id',
  `title` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '标题',
  `subtitle` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '副标题',
  `tag` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '英文标识',
  `pid` int(9) NOT NULL COMMENT '父id',
  `mid` int(9) NOT NULL COMMENT '模板id',
  `img` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '图片',
  `seo_title` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'seo标题',
  `seo_keywords` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'seo关键字',
  `seo_describe` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'seo描述',
  `jump_url` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '外部链接',
  `tpl_cover` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '封面模板',
  `tpl_list` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '列表页模板',
  `tpl_detail` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '详情页模板',
  `rank` smallint(5) NOT NULL DEFAULT 50 COMMENT '排序',
  `is_cover` tinyint(1) NOT NULL DEFAULT 1 COMMENT '1封面页，0列表页',
  `status` tinyint(1) NOT NULL DEFAULT 1 COMMENT '1显示，2不显示',
  `target` tinyint(1) NOT NULL DEFAULT 1 COMMENT '1新窗口,2当前窗口',
  `nav` tinyint(1) NOT NULL DEFAULT 1 COMMENT '1不显示，2主导航，3尾导航，4都显示',
  `desc` varchar(1000) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '简介',
  `content` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL COMMENT '内容',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '栏目表' ROW_FORMAT = Compact;

-- ----------------------------
-- Table structure for jd_config
-- ----------------------------
DROP TABLE IF EXISTS `jd_config`;
CREATE TABLE `jd_config`  (
  `id` smallint(5) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '配置名称',
  `tag` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '英文标识',
  `val` text CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '值',
  `exp` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '说明',
  `type` tinyint(3) NOT NULL COMMENT '类型',
  `show_type` tinyint(1) NOT NULL DEFAULT 1 COMMENT '1 普通文本，2 图片',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 23 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '配置表' ROW_FORMAT = Compact;

-- ----------------------------
-- Records of jd_config
-- ----------------------------
INSERT INTO `jd_config` VALUES (1, 'SEO标题', 'seo_title', '几度CMS系统', '此处为网站首页的seo标题', 1, 1);
INSERT INTO `jd_config` VALUES (2, 'SEO关键字', 'seo_keywords', '几度CMS系统', '此处为网站首页的seo关键字', 1, 1);
INSERT INTO `jd_config` VALUES (3, 'SEO描述', 'seo_describe', '几度CMS系统', '此处为网站首页的seo描述', 1, 1);
INSERT INTO `jd_config` VALUES (4, '网站名称', 'site_title', '几度CMS系统', '请填写您的网站名称', 2, 1);
INSERT INTO `jd_config` VALUES (5, '网站域名', 'site_url', 'http://www.cmsdemo.com', '请填写正确的网站域名，需要加http://或者https://，结尾请勿加/，例如 http://www.jiducms.com', 2, 1);
INSERT INTO `jd_config` VALUES (6, '网站LOGO', 'site_logo', '/uploads/20200107/87764bf986b4abe7341a165af329dc87.png', '请选择您的网站logo', 2, 2);
INSERT INTO `jd_config` VALUES (7, '网站ICO', 'site_ico', '/uploads/20200519/3cbf37a76cab248abab0235efdfd2aac.png', '请选择您的网站ico', 2, 2);
INSERT INTO `jd_config` VALUES (10, '手机站LOGO', 'wap_logo', '/uploads/20200107/87764bf986b4abe7341a165af329dc87.png', '请选择您的手机网站logo', 3, 2);
INSERT INTO `jd_config` VALUES (12, '上传文件大小', 'upload_file_size', '2000', '单位：KB', 4, 1);
INSERT INTO `jd_config` VALUES (13, '上传文件格式', 'upload_file_ext', 'rar,zip,pdf,doc,docx,xls,xlsx,ttf', '多个格式请用英文逗号\",\"隔开', 4, 1);
INSERT INTO `jd_config` VALUES (14, '上传图片大小', 'upload_image_size', '50000', '单位：KB', 4, 1);
INSERT INTO `jd_config` VALUES (15, '上传图片格式', 'upload_image_ext', 'jpg,png,gif,ico,jpeg', '多个格式请用英文逗号\",\"隔开', 4, 1);
INSERT INTO `jd_config` VALUES (16, '上传图片水印', 'upload_watermark', '', '图片水印，文字水印', 5, 1);
INSERT INTO `jd_config` VALUES (17, '上传视频大小', 'upload_video_size', '204800', '单位：KB', 4, 1);
INSERT INTO `jd_config` VALUES (18, '上传视频格式', 'upload_video_ext', 'AVI,mov,rmvb,rm,FLV,mp4,3GP', '多个格式请用英文逗号\",\"隔开', 4, 1);
INSERT INTO `jd_config` VALUES (19, '上传音频大小', 'upload_audio_size', '102400', '单位：KB', 4, 1);
INSERT INTO `jd_config` VALUES (20, '上传音频格式', 'upload_audio_ext', 'mp3,WMA,WAV,MIDI', '多个格式请用英文逗号\",\"隔开', 4, 1);
INSERT INTO `jd_config` VALUES (21, '邮箱账号', 'email_name', '', 'smtp登录的账号 这里填入字符串格式的邮箱账号号即可', 6, 1);
INSERT INTO `jd_config` VALUES (22, '授权码', 'email_pass', '', 'smtp登录的密码 使用生成的授权码【非常重要：在网页上登陆邮箱后在设置中去获取此授权码】', 6, 1);

-- ----------------------------
-- Table structure for jd_content
-- ----------------------------
DROP TABLE IF EXISTS `jd_content`;
CREATE TABLE `jd_content`  (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '内容id',
  `cid` int(9) NOT NULL COMMENT '栏目id',
  `mid` int(9) NOT NULL COMMENT '模板id',
  `title` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '标题',
  `img` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '展示图',
  `jump_url` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '跳转外部链接',
  `browse` int(9) NOT NULL DEFAULT 0 COMMENT '浏览量',
  `the_id` int(9) NOT NULL COMMENT '对应自定义表的id',
  `rank` smallint(5) NOT NULL DEFAULT 50 COMMENT '排序',
  `recommend` tinyint(1) NOT NULL COMMENT '1推荐，2不推荐',
  `time` datetime NOT NULL COMMENT '创建时间',
  `edit_time` datetime NULL DEFAULT NULL COMMENT '最后编辑时间',
  `seo_title` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'seo标题',
  `seo_keywords` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'seo关键字',
  `seo_describe` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'seo描述',
  `tag` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '标签，英文逗号隔开',
  `custom_title` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '自定义页面标题',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '内容表' ROW_FORMAT = Compact;

-- ----------------------------
-- Table structure for jd_diy_article
-- ----------------------------
DROP TABLE IF EXISTS `jd_diy_article`;
CREATE TABLE `jd_diy_article`  (
  `id` int(9) NOT NULL AUTO_INCREMENT COMMENT '文章id',
  `diy_title` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '文章标题',
  `author` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '发布者',
  `desc` varchar(500) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '简介',
  `content` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL COMMENT '内容',
  `diy_time` datetime NOT NULL COMMENT '发布时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '文章表-系统表' ROW_FORMAT = Compact;

-- ----------------------------
-- Table structure for jd_diy_product
-- ----------------------------
DROP TABLE IF EXISTS `jd_diy_product`;
CREATE TABLE `jd_diy_product`  (
  `id` int(9) NOT NULL AUTO_INCREMENT COMMENT '产品id',
  `diy_title` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '产品名称',
  `diy_img` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '展示图',
  `desc` varchar(500) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '产品简介',
  `content` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL COMMENT '内容',
  `diy_time` datetime NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '产品表-系统表' ROW_FORMAT = Compact;

-- ----------------------------
-- Table structure for jd_link
-- ----------------------------
DROP TABLE IF EXISTS `jd_link`;
CREATE TABLE `jd_link`  (
  `id` smallint(5) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `title` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '网站名称',
  `img` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '图片',
  `url` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '网站链接',
  `rank` smallint(5) NOT NULL DEFAULT 50 COMMENT '排序',
  `time` datetime NOT NULL COMMENT '添加时间',
  `edit_time` datetime NOT NULL COMMENT '最后编辑时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 5 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '友情链接表' ROW_FORMAT = Compact;

-- ----------------------------
-- Records of jd_link
-- ----------------------------
INSERT INTO `jd_link` VALUES (4, '几度CMS', '/uploads/20200102/d7ee9be95d98d85281859b060245fe58.png', 'https://www.jiducms.com', 1, '0000-00-00 00:00:00', '0000-00-00 00:00:00');

-- ----------------------------
-- Table structure for jd_user
-- ----------------------------
DROP TABLE IF EXISTS `jd_user`;
CREATE TABLE `jd_user`  (
  `id` tinyint(1) NOT NULL,
  `name` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '云平台账号',
  `phone` varchar(11) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '云平台手机',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '云平台绑定用户表' ROW_FORMAT = Compact;

-- ----------------------------
-- Records of jd_user
-- ----------------------------
INSERT INTO `jd_user` VALUES (1, '琪琪', '13000000000');

SET FOREIGN_KEY_CHECKS = 1;
